# -*- coding: iso-8859-15 -*-

import sys

import host
import bf2

from game.spawners import createSpawner
from game.utils.debugging import *
from game.utils.messaging import *
from game.utils.timer import now

REQUEST_TIME = 60 # delay in seconds between kit requests

def init():
	# while developing the script: disabled unless TK punish is enabled
	if bf2.serverSettings.getTKPunishEnabled():
		host.registerHandler('RemoteCommand', onRemoteCommand)
		host.registerHandler("ChatMessage", onChatMessage, 1)
		host.registerHandler('PlayerSpawn', onPlayerSpawn)

def onPlayerSpawn(player, soldier):
	# player can request a new kit after re-spawning
	player.got_kit_at = now() - REQUEST_TIME

def onRemoteCommand(playerId, cmd):
	global g_rps
	
	if cmd != 'request_kit':
		return
	
	if playerId == -1:
		playerId = 255 # single player or lan host

def onChatMessage(playerId, text, channel, flags):
	try:
		if channel != "Global": return
		text = text.replace("*DEAD*","")
		parts = text.split()
		if len(parts) == 0: return

		# fix for local and singleplayer servers
		if playerId == -1: playerId = 255

		player = bf2.playerManager.getPlayerByIndex(playerId)
		if player == None or player.isValid() == False: return

		position = player.getDefaultVehicle().getPosition()
		team = player.getTeam()

		if parts[0] == "request":
			if len(parts) == 2:
				message("received kit request from " + player.getName() + " for kit " + parts[1])
				if (player.got_kit_at == None) or (player.got_kit_at <= now() - REQUEST_TIME):
					player.got_kit_at = now()
					createSpawner(parts[1] + '_spawner', (position[0], position[1]-1.0, position[2]), None, True, {'timeToLive': 30, 'team': team, 'distance': 0} ) 
				else:
					message(player.getName() + ", you cannot request a kit so soon after your last one, you have to wait " + str(player.got_kit_at + 60 - now()) + " seconds.")

	except:
		debug()
