import host
import bf2.PlayerManager
import bf2.GameLogic
from game.stats.constants import *
from bf2 import g_debug
from bf2.stats.stats import getStatsMap
import socket

passcode="fftf"

eor_kits = {
  0: [KIT_TYPE_AT],
  1: [KIT_TYPE_ASSAULT],
  2: [KIT_TYPE_ENGINEER],
  3: [KIT_TYPE_MEDIC],
  4: [KIT_TYPE_SPECOPS],
  5: [KIT_TYPE_SUPPORT],
  6: [KIT_TYPE_SNIPER],
}

eor_vehicles = {
  0: [VEHICLE_TYPE_ARMOR],
  1: [VEHICLE_TYPE_AVIATOR],
  2: [VEHICLE_TYPE_AIRDEFENSE],
  3: [VEHICLE_TYPE_HELICOPTER],
  4: [VEHICLE_TYPE_TRANSPORT],
  5: [VEHICLE_TYPE_ARTILLERY],
  6: [VEHICLE_TYPE_GRNDDEFENSE],
}

def invoke():
	print "starting 21CW end-of-round data-send"

	# collect needed stats
	e = {}
	
	statsMap = getStatsMap()
	
	# find top player in different categories
	for sp in statsMap.itervalues():
		for k in range(0, NUM_KIT_TYPES + 1):
			if k in sp.kits and sp.kits[k].timeInObject > 0:
				findTop(e, "sk" + str(k), "skn" + str(k), sp.kits[k].score, sp.name)

		for v in range(0, NUM_VEHICLE_TYPES + 1):
			if v in sp.vehicles and sp.vehicles[v].timeInObject > 0:
				findTop(e, "sv" + str(v), "svn" + str(v), sp.vehicles[v].score, sp.name)

		findTop(e, "ts", "tsn", sp.teamScore, sp.name)
		findTop(e, "ss", "ssn", sp.skillScore, sp.name)
		findTop(e, "cpc", "cpcn", sp.localScore.cpCaptures, sp.name)
		findTop(e, "cpa", "cpan", sp.localScore.cpAssists, sp.name)
		findTop(e, "cpd", "cpdn", sp.localScore.cpDefends, sp.name)
		findTop(e, "ka", "kan", sp.localScore.damageAssists + sp.localScore.targetAssists + sp.localScore.passengerAssists, sp.name)
		findTop(e, "he", "hen", sp.localScore.heals, sp.name)
		findTop(e, "rev", "revn", sp.localScore.revives, sp.name)
		findTop(e, "rsp", "rspn", sp.localScore.ammos, sp.name)
		findTop(e, "rep", "repn", sp.localScore.repairs, sp.name)
		findTop(e, "drs", "drsn", sp.localScore.driverSpecials + sp.localScore.driverAssists, sp.name)
		
	
	# find top-3
	if len(statsMap) > 0:
		sortedPlayers = []
		for sp in statsMap.itervalues():
			sortedPlayers += [((sp.score, sp.skillScore, -sp.deaths), sp)]
	
		sortedPlayers.sort()
		sortedPlayers.reverse()
		
		# stats for top-3 scoring players
		for i in range(3):
			if len(sortedPlayers) <= i:
				break
	
			sp = sortedPlayers[i][1]
			e["np" + str(i)] = sp.name
			e["tsp" + str(i)] = sp.teamScore
			e["ssp" + str(i)] = sp.skillScore
			e["csp" + str(i)] = sp.cmdScore
			e["bfp" + str(i)] = sp.bulletsFired
			e["bhp" + str(i)] = sp.bulletsHit
			for k in range(0, NUM_KIT_TYPES + 1):
				if sp.kits[k].timeInObject > 0:
					e["tk" + str(k) + "p" + str(i)] = int(sp.kits[k].timeInObject)
					
			for v in range(0, NUM_VEHICLE_TYPES + 1):
				if sp.vehicles[v].timeInObject > 0:
					e["tv" + str(v) + "p" + str(i)] = int(sp.vehicles[v].timeInObject)
	
	keyvals = []
	for k in e:
		keyvals.append ("\\".join((k, str(e[k]))))

	dataString = "\\" + "\\".join(keyvals)
	
	print "continuing 21CW end-of-round data-send: 4"

	# send stats to the server
	# http://www.bfeditor.org/forums/index.php?showtopic=12532
	statsData = get_statsData()
	print "continuing 21CW end-of-round data-send: 4b"
	send_statsData(statsData)
	
	print "continuing 21CW end-of-round data-send: 5"
	
	if g_debug: print dataString
	host.gl_sendEndOfRoundData(dataString)
	
	
		
def findTop(e, vkey, nkey, value, name):
	if not vkey in e or value > e[vkey]:
		e[vkey] = value
		e[nkey] = name
	
# send stats to the server
# http://www.bfeditor.org/forums/index.php?showtopic=12532
def get_statsData():
          
                result = str(host.rcon_invoke('sv.serverIP'))
                for line in result.splitlines():
                        parts = line.split(" ")
                serverIP = parts[0]

                # START THE XML BLOCK AND SET BASIC ROUND AND SERVER DATA
                dataStream = "<ROUND sip='" + serverIP + "' pcode='" + passcode + "' map='" + host.sgl_getMapName() + "' winteam='" + str(bf2.gameLogic.getWinner()) +  "' > \n"

                # PLAYER KILLS USE CONNECTION ORDER, SO FIRST LIST ALL PLAYERS WITH THEIR CONNECTION ORDER AND PLAYER ID
                for co in bf2.playerManager.getPlayers():
                           dataStream  += "  <CORDER pco='" + str(co.stats.connectionOrderNr) + "' pid='" + str(co.stats.profileId) + "' />\n"

                # NOW WE CYCLE THROUGH ALL PLAYERS AND GET EACH PLAYERS' STATS
                for sp in bf2.playerManager.getPlayers():

                                # START THE PLAYER DATA BLOCK
                                dataStream += "  <PLAYERDATA pname='" + str(sp.stats.name) + "' pId='" + str(sp.stats.profileId) + "'>\n"

                                # NOW GET WHATEVER DATA YOU WANT FOR EACH PLAYER AND PUT IT IN WHATEVER TAGS YOU WANT
                                # SCORE, KILLS NUM AND STREAKS, CPCAPTURES, TIME PLAYED ETC - THIS ONE GIVES THE BASIC SCORES
                                dataStream += "   <SCORE pscore='" + str(sp.stats.score) + "' pteam='" + str(sp.stats.teamScore) + "' pskill='" + str(sp.stats.skillScore) + "' />\n"

                                # NEXT IF YOU WANT, GET THE PLAYER KIT, WEAPON AND VEHICLE USE, SAME FOR OTHERS
                                dataStream += "   <PLAYERKITS> \n"
                                for k, cats in eor_kits.items():
                                                tio = 0.0
                                                kill = 0
                                                death = 0
                                                for cat in cats:
                                                                if cat in sp.stats.kits:
                                                                                tio += sp.stats.kits[cat].timeInObject
                                                                                kill += sp.stats.kits[cat].kills
                                                                                death += sp.stats.kits[cat].deaths
                                                if tio > 0.0:
                                                                dataStream += "   <KIT kid='" + str(k) + "' ktime='" + str(int(tio)) + "' kkill='" + str(kill) + "' kdeath='" + str(death) + "' />\n"
                                dataStream += "   </PLAYERKITS> \n"

                                # NOW ITS TIME TO LIST THE PLAYER KILLS
                                dataStream += "   <PLAYERKILLS> \n"
                                for k, v in sp.stats.killedPlayer.items():
                                                dataStream += "    <KILL victimid='" + str( k ) + "' numkills='" + str( v ) + "' /> \n"
                                dataStream += "   </PLAYERKILLS> \n"

                                # CLOSE THE PLAYER BLOCK
                                dataStream += "  </PLAYERDATA> \n"
                        # CLOSE THE ROUND BLOCK
                dataStream+= "</ROUND>"
                return dataStream


def send_statsData(statFile):
                
                #MOST OF THIS CODE BY ELXX FOR BATTLERACER MOD
                #UPDATED FOR SIMPLE WEBHOST USE BY BFP2
                
                sServer = "excalibur.homeunix.net" # eg: "bfpirates.com"
                sPort = 80
                sParseFile = "/fftf/battle-stats/fftf_receiver.php" # eg:"/bfp2stats/parsestats.php"
                                
                # trufile = statFile.replace("\n", '%0D%0A')
                trufile = statFile
                length = len(trufile)
                
                message = "POST "+str(sParseFile)+" HTTP/1.0\nAccept: */*\nAccept-Language: EN\nHost: "+str(sServer)+"\nContent-type: application/octet-stream\nContent-length: "+str(length)+"\n\n"+str(trufile)

                print("Creating socket")
                sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                print("Setting to non-blocking")
                sock.settimeout(1.0)
                print("Connecting to stat server")
                try:
                                sock.connect((sServer, sPort))
                except:
                                print("Stat Error - Could not connect to stat server")
                                sock.close()
                #       return 0
                print("Sending message")
                messlen = 0
                tries = 0
                fail = 0
                data = ""
                while messlen < len(message):
                                tries += 1
                                if tries >= 2:
                                                print("Failed to send complete message")
                                                fail = 1
                                                break
                                try: messlen += sock.send(message)
                                except Exception, e:
					print "Failed sending stats: ", e
                                if messlen != len(message):
                                                print("Send looping...")
                
                if fail == 0:
                                print("Data sent to stat server - Getting response")
                                data = ""
                
                print("Closing socket")
                sock.close()

